#! /usr/bin/perl -w
use FindBin;
use lib "$FindBin::Bin/../lib";
use Pastel;

use strict;

my $sx=320;
my $sy=240;
my  $xmin = -2;
my  $xmax =1.25;
my  $ymin=-1.25;
my  $ymax=1.25;
my  $maxiter=100;

my $old_x;
my $fx;
my $fy;
my $m;

my $dx=($xmax-$xmin)/$sx;
my $dy=($ymax-$ymin)/$sy;

my $px;
my $py=0;
my $x;
my $y=$ymin;

my $g = Pastel::Graphics->new(-width=>$sx, -height=>$sy);

 #$g->setColor(Color.black);
 #g.drawString("Rendering Mandelbrot..... please wait", 72, 220);
  while ( $py<$sy) {
	$px=0;
	 $x=$xmin;
	 $py++;
	 while ($px<$sx) {
		$px++;

		$fx=0;           
		$fy=0;
		$m=0;            
		do {
		  $old_x=$fx;      
		  $fx=$fx*$fx-$fy*$fy+$x;   
		  $fy=2*$old_x*$fy+$y;  
		  $m++;
		  #print $m, "\n";
		} while ((($fx*$fx+$fy*$fy)<4) && ($m<$maxiter)); 
	    if ($m%2==0){ $g->set_paint(Pastel::Color->white());}
	    if ($m%3==0){ $g->set_paint(Pastel::Color->green());}
	    if ($m%4==0){ $g->set_paint(Pastel::Color->blue());}
	    if ($m%5==0){ $g->set_paint(Pastel::Color->red());}
	    if ($m%6==0){ $g->set_paint(Pastel::Color->yellow())}
	    if ($m%7==0){ $g->set_paint(Pastel::Color->cyan());}
	    if ($m%8==0){ $g->set_paint(Pastel::Color->magenta());}
	    if ($m%9==0){ $g->set_paint(Pastel::Color->orange());}
	    if ($m%10==0){ $g->set_paint(Pastel::Color->pink());}
	    if ($m%11==0){ $g->set_paint(Pastel::Color->gray());}
	    if ($m%12==0){ $g->set_paint(Pastel::Color->red());}
	    if ($m%13==0){ $g->set_paint(Pastel::Color->black());}	
	 $g->draw_line($px-3,$py-3,$px+10,$py+10);
	 $x+=$dx;
	 }
  $y+=$dy;
  }
  #g.setColor(Color.black);
  #g.drawString("Java Mandelbrot By MN Karthik", 3, 10);
  #  }
  #public String getAppletInfo() {
   # return "Java Mandelbrot by MN Karthik (mnkarthik@yahoo.com)";
  #}
#}

$g->show();
