#!/usr/bin/perl -w
#require_ok('Pastel::Text::AttributedString');
use blib;
use Pastel;


use Test::More 'no_plan';

require_ok('Pastel::Text::AttributedString');

my $as = Pastel::Text::AttributedString->new("Whatever");
ok(defined($as));

ok($as->{string} eq "Whatever");

my $as1 = Pastel::Text::AttributedString->new(-text=>"I am Malay Basu");
ok(defined($as1));
ok($as1->{string} eq 'I am Malay Basu');
ok($as1->{string_length} == 15);

$as1->add_attribute("FAMILY", "Arial");
$as1->add_attribute("SIZE", 15);

#print STDERR $as1->to_svg(), "\n";
ok(${$as1->{root_attribute}}{"FAMILY"} eq "Arial");
ok(${$as1->{root_attribute}}{"SIZE"} == 15);

$as1->add_attribute("FAMILY", "verdana", 0,14);
ok(${$as1->{root_attribute}}{'FAMILY'} eq "verdana");

$as1->add_attribute("COLOR", Pastel::Color->red(), 5, 9);
ok($as1->{runcount} == 3);

ok(!defined($as1->_get_run_attributes_as_array(0)));
my $a = join(":",$as1->_get_run_attributes_as_array(1));

ok($a eq "fill:#ff0000");
ok(!defined($as1->_get_run_attributes_as_array(2)));

$as1 = Pastel::Text::AttributedString->new(-text=>"I am Malay Basu");
$as1->add_attribute("STROKE_WIDTH", "10", 0 , 3);
ok($as1->{runcount} == 2);
ok($as1->_get_run_start(0) == 0);
ok($as1->_get_run_end(0) == 3);

$as1 = Pastel::Text::AttributedString->new(-text=>"I am Malay Basu");
$as1->add_attribute("STROKE_COLOR", Pastel::Color->black(),5, 14);
ok($as1->{runcount} == 2);
$a = join(":",$as1->_get_run_attributes_as_array(1));
ok($a eq "stroke:#000000");

$as1 = Pastel::Text::AttributedString->new(-text=>"I am Malay Basu");
$as1->add_attribute("FAMILY", "Arial");
$as1->add_attribute("COLOR", Pastel::Color->red(), 5, 9);
$as1->add_attribute("POSTURE", "ITALIC", 5, 5);

#print STDERR $as1->to_svg(), "\n";

$as1 = Pastel::Text::AttributedString->new(-text=>"I am Malay Basu");
$as1->add_attribute("FAMILY", "Arial");
$as1->add_attribute("COLOR", Pastel::Color->red(), 5, 9);
$as1->add_attribute("POSTURE", "ITALIC", 5, 9);
$as1->add_attribute("STROKE_WIDTH", "15", 5, 5);
$as1->add_attribute("COLOR", Pastel::Color->green(), 11, 14);
#print STDERR $as1->to_svg(), "\n";
###require_ok('Pastel::Text::AttributeEntry');
###my $ae = Pastel::Text::AttributeEntry

my $as2 = Pastel::Text::AttributedString->new(-text=>"Malay");
my $font1 = Pastel::Font->new(-family=>"Arial",-style=>"bold",-size=>12);
$as2->add_attribute("FONT", $font1);
my $font2 = Pastel::Font->new(-family=>"Verdana",-style=>"bold",-size=>12);
$as2->add_attribute("FONT", $font2, 0,1);

#print STDERR $as2->to_svg(), "\n";

##ok($as2->to_svg() eq '<text style="font-weight:bold;font-family:Arial;font-size:12;"><tspan style="font-weight:bold;font-family:Verdana;font-size:12;">Ma</tspan>lay</text>');

my %att;
$att{FONT} = $font1;

my $as3 = Pastel::Text::AttributedString->new(-text=>"Malay",-attributes=> \%att );

#ok($as3->to_svg(), '<text style="font-weight:bold;font-family:Arial;font-size:12;">Malay</text>');

$as3->set_x(12);
$as3->set_y(24);
ok($as3->get_x() == 12);
ok($as3->get_y() == 24);

$as3->set_x([1,2,3,4]);
ok($as3->get_x() eq "1 2 3 4");
$as3->set_y([1,2,3,4]);
ok($as3->get_x() eq "1 2 3 4");

#print STDERR $as3->to_svg(), "\n";

my $g = Pastel::Graphics->new();
$g->draw_string($as2, 100, 200);
#print STDERR $g->get_svg(), "\n";
